package dev.shadowsoffire.apotheosis.ench.enchantments;

import net.minecraft.Util;
import com.google.common.collect.Maps;
import net.minecraft.world.level.block.Blocks;
import java.util.EnumMap;
import net.minecraft.tags.ItemTags;
import java.util.List;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.entity.animal.Sheep;
import net.minecraft.world.entity.EquipmentSlot;
import dev.shadowsoffire.apotheosis.ench.EnchModule;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.item.DyeColor;
import java.util.Map;
import net.minecraft.world.item.enchantment.Enchantment;

public class ChromaticEnchant extends Enchantment
{
    private static final Map<DyeColor, ItemLike> ITEM_BY_DYE;
    
    public ChromaticEnchant() {
        super(Enchantment.Rarity.UNCOMMON, EnchModule.SHEARS, new EquipmentSlot[] { EquipmentSlot.MAINHAND, EquipmentSlot.OFFHAND });
    }
    
    public int m_6183_(final int pLevel) {
        return 40;
    }
    
    public List<ItemStack> molestSheepItems(final Sheep sheep, final ItemStack shears, final List<ItemStack> items) {
        if (shears.getEnchantmentLevel((Enchantment)this) > 0) {
            for (int i = 0; i < items.size(); ++i) {
                if (items.get(i).m_204117_(ItemTags.f_13167_)) {
                    items.set(i, new ItemStack((ItemLike)ChromaticEnchant.ITEM_BY_DYE.get(DyeColor.m_41053_(sheep.f_19796_.m_188503_(16)))));
                }
            }
        }
        return items;
    }
    
    static {
        ITEM_BY_DYE = (Map)Util.m_137469_((Object)Maps.newEnumMap((Class)DyeColor.class), map -> {
            map.put((Enum)DyeColor.WHITE, Blocks.f_50041_);
            map.put((Enum)DyeColor.ORANGE, Blocks.f_50042_);
            map.put((Enum)DyeColor.MAGENTA, Blocks.f_50096_);
            map.put((Enum)DyeColor.LIGHT_BLUE, Blocks.f_50097_);
            map.put((Enum)DyeColor.YELLOW, Blocks.f_50098_);
            map.put((Enum)DyeColor.LIME, Blocks.f_50099_);
            map.put((Enum)DyeColor.PINK, Blocks.f_50100_);
            map.put((Enum)DyeColor.GRAY, Blocks.f_50101_);
            map.put((Enum)DyeColor.LIGHT_GRAY, Blocks.f_50102_);
            map.put((Enum)DyeColor.CYAN, Blocks.f_50103_);
            map.put((Enum)DyeColor.PURPLE, Blocks.f_50104_);
            map.put((Enum)DyeColor.BLUE, Blocks.f_50105_);
            map.put((Enum)DyeColor.BROWN, Blocks.f_50106_);
            map.put((Enum)DyeColor.GREEN, Blocks.f_50107_);
            map.put((Enum)DyeColor.RED, Blocks.f_50108_);
            map.put((Enum)DyeColor.BLACK, Blocks.f_50109_);
        });
    }
}
